## vsxu-0.6.3.0.tar.gz

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
if(POLICY CMP0040)
  cmake_policy(SET CMP0040 OLD)
endif()

PROJECT(VSXu)

set(VSXU_VERSION_MAJOR "0")
set(VSXU_VERSION_MINOR "6")
set(VSXU_VERSION_PATCH "3")
set(VSXU_VERSION ${VSXU_VERSION_MAJOR}.${VSXU_VERSION_MINOR}.${VSXU_VERSION_PATCH})

message("---------------------------------------------------------------------")
message("                     Configuring Vovoid VSXu                         ")
message("=====================================================================")
################################################################################
# CMAKE MODULE PATH ############################################################
################################################################################
set (CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake/modules)

################################################################################
# GLOBAL INSTALL VARIABLES #####################################################
################################################################################

if(CMAKE_SYSTEM_NAME MATCHES "Linux")
    set(VSXU_INSTALL_INCLUDE_DIR "include/vsxu")
    set(VSXU_INSTALL_LIB_DIR "lib${LIB_SUFFIX}")
    set(VSXU_INSTALL_BIN_DIR "bin")
    set(VSXU_INSTALL_SHARE_DIR "share/vsxu")
endif()

if(CMAKE_SYSTEM_NAME STREQUAL "Windows")
    if (VSXU_WINDOWS_LIB_BUILD)
      set(VSXU_INSTALL_INCLUDE_DIR "include/vsxu")
      set(VSXU_INSTALL_LIB_DIR "lib${LIB_SUFFIX}")
      set(VSXU_INSTALL_BIN_DIR "bin")
      set(VSXU_INSTALL_SHARE_DIR "share/vsxu")
    else()
      set(VSXU_INSTALL_INCLUDE_DIR "include")
      set(VSXU_INSTALL_LIB_DIR ".")
      set(VSXU_INSTALL_BIN_DIR ".")
      set(VSXU_INSTALL_SHARE_DIR "share")
    endif()
endif()

######################################################################################
enable_testing()

######################################################################################
# Install the Global Headers so as to install VSXu as a library
if (UNIX OR VSXU_WINDOWS_LIB_BUILD)
  file(GLOB HEADERS "*.h")
  install (FILES ${HEADERS} DESTINATION ${CMAKE_INSTALL_PREFIX}/${VSXU_INSTALL_INCLUDE_DIR} COMPONENT Devel)
endif()




################################################################################
# DEFINES ######################################################################
################################################################################

# C++14: set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++1y")
#set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fpermissive" )

if (MSVC)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -MP8")
  set(VSXU_STATIC 1)
  add_definitions(-DVSXU_STATIC)
  add_definitions(-DGLEW_STATIC)
  add_definitions(-D_CRT_SECURE_NO_WARNINGS)
  include_directories( dependencies/SDL2_prebuilt_windows/include )
  include_directories( dependencies/glew-1.7.0/include )
  include_directories( lib/engine_graphics/thirdparty/ftgl)
  include_directories( lib/engine_graphics/thirdparty/ftgl/src)
  include_directories( lib/engine_graphics/thirdparty/freetype2/include )
  include_directories( lib/engine_graphics/thirdparty/freetype2/include/freetype )
  include_directories( lib/engine_graphics/thirdparty/freetype2/include/freetype/config )

else()
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11" )
    add_definitions( -Wall -Wno-sign-compare)
    add_definitions(-fmax-errors=500)

    if (VSXU_STATIC EQUAL 1)
      add_definitions(-g)
      add_definitions(-DVSXU_STATIC)
      add_definitions(-DGLEW_STATIC)
    endif()

    if(VSXU_DEBUG_SYMBOLS)
      add_definitions(-g)
    endif()
endif()

if (VSXU_STATIC_AUDIO_SINK EQUAL 1)
  add_definitions(-DVSXU_AUDIO_SINK=1)
endif()

if (VSX_PRINTF_TO_FILE EQUAL 1)
  add_definitions(-DVSX_PRINTF_TO_FILE)
endif()



include (cmake/optimization.txt)

add_definitions(-DVSXU_INSTALL_LIB_DIR="${VSXU_INSTALL_LIB_DIR}")
#add_definitions(-DVSX_VECTOR_TYPE_DOUBLE=1)



################################################################################
# VSXU LIBRARIES ###############################################################
################################################################################
add_subdirectory(lib/engine_graphics)

# order matters - need to add plugins before engine to create static glue ######
add_subdirectory(plugins)
################################################################################

add_subdirectory(lib/application)
add_subdirectory(lib/common)
add_subdirectory(lib/compression)
add_subdirectory(lib/engine)
add_subdirectory(lib/widget)

################################################################################
# VSXU IMPLEMENTATIONS/BINARIES ################################################
################################################################################
add_subdirectory(programs/launcher)
add_subdirectory(programs/artiste)
add_subdirectory(programs/player)
if (VSXU_DEMO_PLAYER)
  add_subdirectory(programs/player_demo)
endif()

add_subdirectory(programs/profiler)

if(UNIX)
 add_subdirectory(programs/server)

endif(UNIX)

add_subdirectory(programs/tools/vsxbt)
add_subdirectory(programs/tools/vsxz)
add_subdirectory(programs/tools/obj2vxm)
add_subdirectory(programs/tools/raw2wav)
if(UNIX)
    add_subdirectory(programs/tools/vsxl)
endif(UNIX)

################################################################################
# The pkg-config file
################################################################################
IF (UNIX OR VSXU_WINDOWS_LIB_BUILD)
  if (VSXU_STATIC EQUAL 1 AND EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/plugins/static_factory_pkgconfig_libs")
    file (STRINGS "${CMAKE_CURRENT_SOURCE_DIR}/plugins/static_factory_pkgconfig_libs" VSXU_PLUGIN_PKGCONFIG_LIBS)
    CONFIGURE_FILE (${CMAKE_CURRENT_SOURCE_DIR}/libvsx.pc.in.static
                    ${CMAKE_CURRENT_BINARY_DIR}/libvsx.pc
                    @ONLY)

  else()
    CONFIGURE_FILE (${CMAKE_CURRENT_SOURCE_DIR}/libvsx.pc.in.dynamic
                    ${CMAKE_CURRENT_BINARY_DIR}/libvsx.pc
                    @ONLY)
  endif()

  INSTALL (FILES ${CMAKE_CURRENT_BINARY_DIR}/libvsx.pc
           DESTINATION ${VSXU_INSTALL_LIB_DIR}/pkgconfig)
ENDIF()



include(CPackLists.txt)

# uninstall target
configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
    IMMEDIATE @ONLY)

add_custom_target(uninstall
    COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)

=== plugins/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

function(CREATE_STATIC_GLUE module_id)
  if (VSXU_STATIC EQUAL 1)
    # create a link directory
    file(APPEND ../../static_factory_cmake_link_directories "link_directories(" ${CMAKE_SOURCE_DIR}/plugins/src/${module_id}/ ")\n" )

    # link library
    file(APPEND ../../static_factory_cmake_target_link_libraries "target_link_libraries(\${module_id} " ${module_id} ")\n" )

    # pkgconfig lib
    file(APPEND ../../static_factory_pkgconfig_libs "-l:${module_id}.a ")

    # make a C++-friendly name out of the module name
    string(REPLACE "." "_" module_id_f ${module_id} )

    # rig up the factory include symbols
    # create defines for code in the engine
    file(APPEND ../../static_factory_funcmapping.h
      "vsx_module* " vsx_module_${module_id_f}_cm "(unsigned long module, void* args);\n"
      "void " vsx_module_${module_id_f}_dm "(vsx_module* m, unsigned long module);\n"
      "unsigned long " vsx_module_${module_id_f}_nm "(vsx_module_engine_environment* environment);\n"
    )
    # create a cpp include file for calls
    file(APPEND ../../static_factory_funcmapping.cpp "  VSXM_SF_ADD_MODULE(\"${module_id}\"," vsx_module_${module_id_f}_cm "," vsx_module_${module_id_f}_dm "," vsx_module_${module_id_f}_nm ");\n")
    add_definitions(
      -DMOD_CM=vsx_module_${module_id_f}_cm
      -DMOD_DM=vsx_module_${module_id_f}_dm
      -DMOD_NM=vsx_module_${module_id_f}_nm
    )


  else  ()


    add_definitions(
      -DMOD_CM=create_new_module
      -DMOD_DM=destroy_module
      -DMOD_NM=get_num_modules
    )
  endif ()

endfunction(CREATE_STATIC_GLUE)


function( CREATE_MODULE ${module_id} )
  if (VSXU_STATIC EQUAL 1)

      GET_PROPERTY(LOCAL_GLOBAL_SOURCES GLOBAL PROPERTY GLOBAL_PLUGIN_SOURCES)
      SET_PROPERTY(GLOBAL PROPERTY GLOBAL_PLUGIN_SOURCES ${LOCAL_GLOBAL_SOURCES} ${LOCAL_SOURCES} ${API_STUBS} ${SOURCES} ${HEADER_FILES})

      GET_PROPERTY(LOCAL_GLOBAL_DEFINITIONS GLOBAL PROPERTY GLOBAL_PLUGIN_DEFINITIONS)
      SET_PROPERTY(GLOBAL PROPERTY GLOBAL_PLUGIN_DEFINITIONS ${LOCAL_GLOBAL_DEFINITIONS} ${DEFINITIONS})

      GET_PROPERTY(LOCAL_GLOBAL_INCLUDE_DIRS GLOBAL PROPERTY GLOBAL_PLUGIN_INCLUDE_DIRS)
      SET_PROPERTY(GLOBAL PROPERTY GLOBAL_PLUGIN_INCLUDE_DIRS ${LOCAL_GLOBAL_INCLUDE_DIRS} ${INCLUDE_DIRS})

  else (VSXU_STATIC EQUAL 1)
    add_library(${module_id} MODULE ${LOCAL_SOURCES} ${API_STUBS} ${SOURCES} ${HEADER_FILES})
  endif (VSXU_STATIC EQUAL 1)
endfunction(CREATE_MODULE)


if (VSXU_STATIC EQUAL 1)
  # 1. create the files for static factory
  file(WRITE static_factory_funcmapping.cpp "")
  file(WRITE static_factory_funcmapping.h "")
  file(WRITE static_factory_cmake_link_directories "")
  file(WRITE static_factory_cmake_target_link_libraries "")
  file(WRITE static_factory_pkgconfig_libs "")
endif()

if (WIN32 AND VSXU_STATIC EQUAL 1)
  add_definitions(-DGLEW_STATIC=1)
  add_definitions(-DFTGL_LIBRARY_STATIC -DFT2_BUILD_LIBRARY)
endif()

add_subdirectory(src/bitmap.generators)
add_subdirectory(src/bitmap.loaders)
add_subdirectory(src/bitmap.modifiers)
add_subdirectory(src/_deprecated)
add_subdirectory(src/math)
add_subdirectory(src/math.oscillators)
add_subdirectory(src/mesh.generators)
add_subdirectory(src/mesh.importers)
add_subdirectory(src/mesh.modifiers)
add_subdirectory(src/mesh.render)
add_subdirectory(src/outputs.screen_opengl)
add_subdirectory(src/particlesystem.generators)
add_subdirectory(src/particlesystem.modifiers)
add_subdirectory(src/particlesystem.render)
add_subdirectory(src/render.basic)
add_subdirectory(src/render.glsl)
add_subdirectory(src/render.gravity_lines)
add_subdirectory(src/render.opengl)
add_subdirectory(src/render.text)
add_subdirectory(src/selectors)

if (VSXU_STATIC_AUDIO_SINK)
  add_definitions(-DVSXU_AUDIO_SINK=1)
  add_subdirectory(src/sound.sink)
else()
  add_subdirectory(src/sound.rtaudio)
endif()

add_subdirectory(src/string)
add_subdirectory(src/system)
add_subdirectory(src/texture)

if (VSXU_STATIC EQUAL 1)
  GET_PROPERTY(SOURCES GLOBAL PROPERTY GLOBAL_PLUGIN_SOURCES)
  GET_PROPERTY(DEFINITIONS GLOBAL PROPERTY GLOBAL_PLUGIN_DEFINITIONS)
  GET_PROPERTY(INCLUDE_DIRS GLOBAL PROPERTY GLOBAL_PLUGIN_INCLUDE_DIRS)
  include_directories(${INCLUDE_DIRS})
  add_definitions(${DEFINITIONS})
  include(${CMAKE_CURRENT_LIST_DIR}/src/cmake_globals.txt)
#  message(${SOURCES})
  add_library(plugins STATIC ${SOURCES})
endif()

=== dependencies/glew-1.7.0/Makefile ===
#!gmake
## The OpenGL Extension Wrangler Library
## Copyright (C) 2002-2008, Milan Ikits <milan ikits[]ieee org>
## Copyright (C) 2002-2008, Marcelo E. Magallon <mmagallo[]debian org>
## Copyright (C) 2002, Lev Povalahev
## All rights reserved.
## 
## Redistribution and use in source and binary forms, with or without 
## modification, are permitted provided that the following conditions are met:
## 
## * Redistributions of source code must retain the above copyright notice, 
##   this list of conditions and the following disclaimer.
## * Redistributions in binary form must reproduce the above copyright notice, 
##   this list of conditions and the following disclaimer in the documentation 
##   and/or other materials provided with the distribution.
## * The name of the author may be used to endorse or promote products 
##   derived from this software without specific prior written permission.
##
## THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
## AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
## IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
## ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE 
## LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
## CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
## SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
## INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
## CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
## ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
## THE POSSIBILITY OF SUCH DAMAGE.

include config/version

SHELL = /bin/sh
SYSTEM ?= $(shell config/config.guess | cut -d - -f 3 | sed -e 's/[0-9\.]//g;')
SYSTEM.SUPPORTED = $(shell test -f config/Makefile.$(SYSTEM) && echo 1)

ifeq ($(SYSTEM.SUPPORTED), 1)
include config/Makefile.$(SYSTEM)
else
$(error "Platform '$(SYSTEM)' not supported")
endif

GLEW_DEST ?= /usr
BINDIR ?= $(GLEW_DEST)/bin
LIBDIR ?= $(GLEW_DEST)/lib
INCDIR ?= $(GLEW_DEST)/include/GL
SHARED_OBJ_EXT ?= o

LIBNAME ?= "GLEW"

TARDIR = ../glew-$(GLEW_VERSION)
TARBALL = ../glew-$(GLEW_VERSION).tar.gz

DIST_DIR     = glew-$(GLEW_VERSION)
DIST_WIN32   = glew-$(GLEW_VERSION)-win32.zip
DIST_SRC_ZIP = glew-$(GLEW_VERSION).zip
DIST_SRC_TGZ = glew-$(GLEW_VERSION).tgz

AR = ar
INSTALL = install
STRIP = strip
RM = rm -f
LN = ln -sf
ifeq ($(MAKECMDGOALS), debug)
OPT = -g
else
OPT = $(POPT)
endif
INCLUDE = -Iinclude
CFLAGS = $(OPT) $(WARN) $(INCLUDE) $(CFLAGS.EXTRA)

LIB.SRCS = src/glew.c
LIB.OBJS = $(LIB.SRCS:.c=.o)
LIB.SOBJS = $(LIB.SRCS:.c=.$(SHARED_OBJ_EXT))
LIB.LDFLAGS = $(LDFLAGS.EXTRA) $(LDFLAGS.GL)
LIB.LIBS = $(GL_LDFLAGS)

LIB.OBJS.MX  = $(LIB.SRCS:.c=.mx.o)
LIB.SOBJS.MX = $(LIB.SRCS:.c=.mx.$(SHARED_OBJ_EXT))

GLEWINFO.BIN = glewinfo$(BIN.SUFFIX)
GLEWINFO.BIN.SRCS = src/glewinfo.c
GLEWINFO.BIN.OBJS = $(GLEWINFO.BIN.SRCS:.c=.o)
VISUALINFO.BIN = visualinfo$(BIN.SUFFIX)
VISUALINFO.BIN.SRCS = src/visualinfo.c
VISUALINFO.BIN.OBJS = $(VISUALINFO.BIN.SRCS:.c=.o)
BIN.LIBS = -Llib $(LDFLAGS.DYNAMIC) -l$(NAME) $(LDFLAGS.EXTRA) $(LDFLAGS.GL)

all debug: glew.lib glew.lib.mx glew.bin

%.o: %.c
	$(CC) -c $(CFLAGS) -o $@ $<

# GLEW libraries

glew.lib: lib lib/$(LIB.SHARED) lib/$(LIB.STATIC) glew.pc

lib:
	mkdir lib

lib/$(LIB.STATIC): $(LIB.OBJS)
	$(AR) cr $@ $^

lib/$(LIB.SHARED): $(LIB.SOBJS)
	$(LD) $(LDFLAGS.SO) -o $@ $^ $(LIB.LDFLAGS) $(LIB.LIBS)
ifeq ($(filter-out mingw% cygwin,$(SYSTEM)),)
else
	$(LN) $(LIB.SHARED) lib/$(LIB.SONAME)
	$(LN) $(LIB.SHARED) lib/$(LIB.DEVLNK)
endif

glew.pc: glew.pc.in
	sed \
		-e "s|@prefix@|$(GLEW_DEST)|g" \
		-e "s|@libdir@|$(LIBDIR)|g" \
		-e "s|@exec_prefix@|$(BINDIR)|g" \
		-e "s|@includedir@|$(INCDIR)|g" \
		-e "s|@version@|$(GLEW_VERSION)|g" \
		-e "s|@cflags@||g" \
		-e "s|@libname@|$(LIBNAME)|g" \
		< $< > $@

glewmx.pc: glewmx.pc.in
	sed \
		-e "s|@prefix@|$(GLEW_DEST)|g" \
		-e "s|@libdir@|$(LIBDIR)|g" \
		-e "s|@exec_prefix@|$(BINDIR)|g" \
		-e "s|@includedir@|$(INCDIR)|g" \
		-e "s|@version@|$(GLEW_VERSION)|g" \
		-e "s|@cflags@||g" \
		-e "s|@libname@|$(LIBNAME)|g" \
		< $< > $@

src/glew.o: src/glew.c include/GL/glew.h include/GL/wglew.h include/GL/glxew.h
	$(CC) -DGLEW_NO_GLU $(CFLAGS) $(CFLAGS.SO) -o $@ -c $<

src/glew.pic_o: src/glew.c include/GL/glew.h include/GL/wglew.h include/GL/glxew.h
	$(CC) -DGLEW_NO_GLU $(CFLAGS) $(PICFLAG) $(CFLAGS.SO) -o $@ -c $<

# GLEW MX libraries

glew.lib.mx:  lib lib/$(LIB.SHARED.MX) lib/$(LIB.STATIC.MX) glewmx.pc

lib/$(LIB.STATIC.MX): $(LIB.OBJS.MX)
	$(AR) cr $@ $^

lib/$(LIB.SHARED.MX): $(LIB.SOBJS.MX)
	$(LD) $(LDFLAGS.SO.MX) -o $@ $^ $(LIB.LDFLAGS) $(LIB.LIBS)
ifeq ($(filter-out mingw% cygwin,$(SYSTEM)),)
else
	$(LN) $(LIB.SHARED.MX) lib/$(LIB.SONAME.MX)
	$(LN) $(LIB.SHARED.MX) lib/$(LIB.DEVLNK.MX)
endif

glewmx.pc: glewmx.pc.in
	sed \
		-e "s|@prefix@|$(GLEW_DEST)|g" \
		-e "s|@libdir@|$(LIBDIR)|g" \
		-e "s|@exec_prefix@|$(BINDIR)|g" \
		-e "s|@includedir@|$(INCDIR)|g" \
		-e "s|@version@|$(GLEW_VERSION)|g" \
		-e "s|@cflags@|-DGLEW_MX|g" \
		-e "s|@libname@|GLEWmx|g" \
		< $< > $@

src/glew.mx.o: src/glew.c include/GL/glew.h include/GL/wglew.h include/GL/glxew.h
	$(CC) -DGLEW_NO_GLU -DGLEW_MX $(CFLAGS) $(CFLAGS.SO) -o $@ -c $<

src/glew.mx.pic_o: src/glew.c include/GL/glew.h include/GL/wglew.h include/GL/glxew.h
	$(CC) -DGLEW_NO_GLU -DGLEW_MX $(CFLAGS) $(PICFLAG) $(CFLAGS.SO) -o $@ -c $<

# GLEW utilities

bin:
	mkdir bin

glew.bin:     glew.lib bin bin/$(GLEWINFO.BIN) bin/$(VISUALINFO.BIN) 

bin/$(GLEWINFO.BIN): $(GLEWINFO.BIN.OBJS) lib/$(LIB.SHARED)
	$(CC) $(CFLAGS) -o $@ $(GLEWINFO.BIN.OBJS) $(BIN.LIBS)

bin/$(VISUALINFO.BIN): $(VISUALINFO.BIN.OBJS) lib/$(LIB.SHARED)
	$(CC) $(CFLAGS) -o $@ $(VISUALINFO.BIN.OBJS) $(BIN.LIBS)

# Install targets

install.all: install install.mx install.bin

install:     install.include install.lib install.pkgconfig

install.mx:  install.include install.lib.mx install.pkgconfig.mx

install.lib: glew.lib
	$(INSTALL) -d -m 0755 $(LIBDIR)
# runtime
ifeq ($(filter-out mingw% cygwin,$(SYSTEM)),)
	$(INSTALL) -d -m 0755 $(BINDIR)
	$(STRIP) -x lib/$(LIB.SHARED)
	$(INSTALL) -m 0755 lib/$(LIB.SHARED) $(BINDIR)/
else
	$(STRIP) -x lib/$(LIB.SHARED)
	$(INSTALL) -m 0644 lib/$(LIB.SHARED) $(LIBDIR)/
	$(LN) $(LIB.SHARED) $(LIBDIR)/$(LIB.SONAME)
endif
# development files
ifeq ($(filter-out mingw% cygwin,$(SYSTEM)),)
	$(INSTALL) -m 0644 lib/$(LIB.DEVLNK) $(LIBDIR)/
else
	$(LN) $(LIB.SHARED) $(LIBDIR)/$(LIB.DEVLNK)
endif
	$(STRIP) -x lib/$(LIB.STATIC)
	$(INSTALL) -m 0644 lib/$(LIB.STATIC) $(LIBDIR)/

install.lib.mx: glew.lib.mx
	$(INSTALL) -d -m 0755 $(LIBDIR)
# runtime
ifeq ($(filter-out mingw% cygwin,$(SYSTEM)),)
	$(INSTALL) -d -m 0755 $(BINDIR)
	$(STRIP) -x lib/$(LIB.SHARED.MX)
	$(INSTALL) -m 0755 lib/$(LIB.SHARED.MX) $(BINDIR)/
else
	$(STRIP) -x lib/$(LIB.SHARED.MX)
	$(INSTALL) -m 0644 lib/$(LIB.SHARED.MX) $(LIBDIR)/
	$(LN) $(LIB.SHARED.MX) $(LIBDIR)/$(LIB.SONAME.MX)
endif
# development files
ifeq ($(filter-out mingw% cygwin,$(SYSTEM)),)
	$(INSTALL) -m 0644 lib/$(LIB.DEVLNK.MX) $(LIBDIR)/
else
	$(LN) $(LIB.SHARED.MX) $(LIBDIR)/$(LIB.DEVLNK.MX)
endif
	$(STRIP) -x lib/$(LIB.STATIC.MX)
	$(INSTALL) -m 0644 lib/$(LIB.STATIC.MX) $(LIBDIR)/

install.bin: glew.bin
	$(INSTALL) -d -m 0755 $(BINDIR)
	$(INSTALL) -s -m 0755 bin/$(GLEWINFO.BIN) bin/$(VISUALINFO.BIN) $(BINDIR)/

install.include:
	$(INSTALL) -d -m 0755 $(INCDIR)
	$(INSTALL) -m 0644 include/GL/wglew.h $(INCDIR)/
	$(INSTALL) -m 0644 include/GL/glew.h $(INCDIR)/
	$(INSTALL) -m 0644 include/GL/glxew.h $(INCDIR)/

install.pkgconfig: glew.pc
	$(INSTALL) -d -m 0755 $(LIBDIR)
	$(INSTALL) -d -m 0755 $(LIBDIR)/pkgconfig
	$(INSTALL) -m 0644 glew.pc $(LIBDIR)/pkgconfig/

install.pkgconfig.mx: glewmx.pc
	$(INSTALL) -d -m 0755 $(LIBDIR)
	$(INSTALL) -d -m 0755 $(LIBDIR)/pkgconfig
	$(INSTALL) -m 0644 glewmx.pc $(LIBDIR)/pkgconfig/

uninstall:
	$(RM) $(INCDIR)/wglew.h
	$(RM) $(INCDIR)/glew.h
	$(RM) $(INCDIR)/glxew.h
	$(RM) $(LIBDIR)/$(LIB.DEVLNK) $(LIBDIR)/$(LIB.DEVLNK.MX)
ifeq ($(filter-out mingw% cygwin,$(SYSTEM)),)
	$(RM) $(BINDIR)/$(LIB.SHARED) $(BINDIR)/$(LIB.SHARED.MX)
else
	$(RM) $(LIBDIR)/$(LIB.SONAME) $(LIBDIR)/$(LIB.SONAME.MX)
	$(RM) $(LIBDIR)/$(LIB.SHARED) $(LIBDIR)/$(LIB.SHARED.MX)
endif
	$(RM) $(LIBDIR)/$(LIB.STATIC) $(LIBDIR)/$(LIB.STATIC.MX)
	$(RM) $(BINDIR)/$(GLEWINFO.BIN) $(BINDIR)/$(VISUALINFO.BIN)

clean:
	$(RM) $(LIB.OBJS) $(LIB.OBJS.MX)
	$(RM) $(LIB.SOBJS) $(LIB.SOBJS.MX)
	$(RM) lib/$(LIB.STATIC) lib/$(LIB.SHARED) lib/$(LIB.DEVLNK) lib/$(LIB.SONAME) $(LIB.STATIC)
	$(RM) lib/$(LIB.STATIC.MX) lib/$(LIB.SHARED.MX) lib/$(LIB.DEVLNK.MX) lib/$(LIB.SONAME.MX) $(LIB.STATIC.MX)
	$(RM) $(GLEWINFO.BIN.OBJS) bin/$(GLEWINFO.BIN) $(VISUALINFO.BIN.OBJS) bin/$(VISUALINFO.BIN)
	$(RM) glew.pc glewmx.pc
# Compiler droppings
	$(RM) so_locations
	$(RM) -r lib/ bin/

distclean: clean
	find . -name \*~ | xargs $(RM)
	find . -name .\*.sw\? | xargs $(RM)

# Distributions

dist-win32:
	$(RM) -r $(TARDIR)
	mkdir -p $(TARDIR)
	mkdir -p $(TARDIR)/bin
	mkdir -p $(TARDIR)/lib
	cp -a include $(TARDIR)
	cp -a doc $(TARDIR)
	cp -a *.txt $(TARDIR)
	cp -a lib/glew32.lib     $(TARDIR)/lib
	cp -a lib/glew32s.lib    $(TARDIR)/lib
	cp -a lib/glew32mx.lib   $(TARDIR)/lib
	cp -a lib/glew32mxs.lib  $(TARDIR)/lib
	cp -a bin/glew32.dll     $(TARDIR)/bin
	cp -a bin/glew32mx.dll   $(TARDIR)/bin
	cp -a bin/glewinfo.exe   $(TARDIR)/bin
	cp -a bin/visualinfo.exe $(TARDIR)/bin
	find $(TARDIR) -name CVS -o -name .cvsignore | xargs $(RM) -r
	find $(TARDIR) -name .svn | xargs $(RM) -r
	find $(TARDIR) -name "*.patch" | xargs $(RM) -r
	unix2dos $(TARDIR)/include/GL/*.h
	unix2dos $(TARDIR)/doc/*.txt
	unix2dos $(TARDIR)/doc/*.html
	unix2dos $(TARDIR)/*.txt
	rm -f ../$(DIST_WIN32)
	cd .. && zip -rv9 $(DIST_WIN32) $(DIST_DIR)

dist-src:
	$(RM) -r $(TARDIR)
	mkdir -p $(TARDIR)
	mkdir -p $(TARDIR)/bin
	mkdir -p $(TARDIR)/lib
	cp -a auto $(TARDIR)
	$(RM) -Rf $(TARDIR)/auto/registry
	cp -a build $(TARDIR)
	cp -a config $(TARDIR)
	cp -a src $(TARDIR)
	cp -a doc $(TARDIR)
	cp -a include $(TARDIR)
	cp -a *.txt $(TARDIR)
	cp -a Makefile $(TARDIR)
	cp -a glew.pc.in $(TARDIR)
	find $(TARDIR) -name '*.o' | xargs $(RM) -r
	find $(TARDIR) -name '*.mx.o' | xargs $(RM) -r
	find $(TARDIR) -name '*.pic_o' | xargs $(RM) -r
	find $(TARDIR) -name '*.mx.pic_o' | xargs $(RM) -r
	find $(TARDIR) -name '*~' | xargs $(RM) -r
	find $(TARDIR) -name CVS -o -name .cvsignore | xargs $(RM) -r
	find $(TARDIR) -name .svn | xargs $(RM) -r
	find $(TARDIR) -name "*.patch" | xargs $(RM) -r
	unix2dos $(TARDIR)/config/*
	unix2dos $(TARDIR)/auto/core/*
	unix2dos $(TARDIR)/auto/extensions/*
	find $(TARDIR) -name '*.h' | xargs unix2dos
	find $(TARDIR) -name '*.c' | xargs unix2dos
	find $(TARDIR) -name '*.txt' | xargs unix2dos
	find $(TARDIR) -name '*.html' | xargs unix2dos
	find $(TARDIR) -name '*.css' | xargs unix2dos
	find $(TARDIR) -name '*.sh' | xargs unix2dos
	find $(TARDIR) -name '*.pl' | xargs unix2dos
	find $(TARDIR) -name 'Makefile' | xargs unix2dos
	find $(TARDIR) -name '*.in' | xargs unix2dos
	find $(TARDIR) -name '*.pm' | xargs unix2dos
	find $(TARDIR) -name '*.rc' | xargs unix2dos
	rm -f ../$(DIST_SRC_ZIP)
	cd .. && zip -rv9 $(DIST_SRC_ZIP) $(DIST_DIR)
	dos2unix $(TARDIR)/config/*
	dos2unix $(TARDIR)/auto/core/*
	dos2unix $(TARDIR)/auto/extensions/*
	find $(TARDIR) -name '*.h' | xargs dos2unix
	find $(TARDIR) -name '*.c' | xargs dos2unix
	find $(TARDIR) -name '*.txt' | xargs dos2unix
	find $(TARDIR) -name '*.html' | xargs dos2unix
	find $(TARDIR) -name '*.css' | xargs dos2unix
	find $(TARDIR) -name '*.sh' | xargs dos2unix
	find $(TARDIR) -name '*.pl' | xargs dos2unix
	find $(TARDIR) -name 'Makefile' | xargs dos2unix
	find $(TARDIR) -name '*.in' | xargs dos2unix
	find $(TARDIR) -name '*.pm' | xargs dos2unix
	find $(TARDIR) -name '*.rc' | xargs dos2unix
	cd .. && env GZIP=-9 tar cvzf $(DIST_SRC_TGZ) $(DIST_DIR)

extensions:
	$(MAKE) -C auto

.PHONY: clean distclean tardist dist-win32 dist-src

=== lib/application/CMakeLists.txt ===
set(module_id vsx_application)

message("configuring            " ${module_id})

################################################################################
project (${module_id})

################################################################################
# CMAKE PACKAGES ###############################################################
################################################################################
include(${CMAKE_SOURCE_DIR}/cmake/CMakeFindLib.txt)
include(${CMAKE_SOURCE_DIR}/cmake/CMakeVSXuGfxLib.txt)


################################################################################
# INCLUDES #####################################################################
################################################################################

include_directories(
  ${CMAKE_SOURCE_DIR}/
  ${CMAKE_SOURCE_DIR}/lib/common/include
  ${CMAKE_SOURCE_DIR}/lib/engine_graphics/include
  ${CMAKE_SOURCE_DIR}/lib/application/include
)

file(GLOB_RECURSE HEADER_FILES *.h)

################################################################################
# DEFINES
################################################################################

add_definitions(
 -DCMAKE_INSTALL_PREFIX="${CMAKE_INSTALL_PREFIX}"
) 

if (VSXU_DEBUG EQUAL 1)
  add_definitions( -DVSXU_DEBUG )
endif (VSXU_DEBUG EQUAL 1)


################################################################################
# SOURCES ######################################################################
################################################################################

if (VSXU_GFX_LIB EQUAL "GLFW")
    set(GFX_LIB_SOURCES
        src/glfw/vsx_mouse.cpp
    )
else()
    set(GFX_LIB_SOURCES
        src/sdl/vsx_application_input_mouse_control.cpp
        src/sdl/vsx_application_run.cpp
    )
endif()

set(SOURCES
  src/vsx_application_control.cpp
  src/vsx_application_manager.cpp
)

################################################################################
# LINKAGE ######################################################################
################################################################################

if (VSXU_STATIC EQUAL 1)
  add_library(${module_id} STATIC ${SOURCES} ${GFX_LIB_SOURCES} ${HEADER_FILES})
else ()
  add_library(${module_id} SHARED ${SOURCES} ${GFX_LIB_SOURCES} ${HEADER_FILES})
endif ()

install(TARGETS ${module_id} DESTINATION ${VSXU_INSTALL_LIB_DIR} COMPONENT common)

######################################################################################
# Install the Headers so as to install VSXu as a library
install (DIRECTORY "include/" DESTINATION ${CMAKE_INSTALL_PREFIX}/${VSXU_INSTALL_INCLUDE_DIR}/application COMPONENT Devel)
################################################################################

if (WIN32)
  if (VSXU_BUILD_WINDOWS_32)
    install(FILES  DESTINATION ${VSXU_INSTALL_BIN_DIR} COMPONENT common)
  endif()
endif()

add_subdirectory(test)

=== lib/common/CMakeLists.txt ===
set(module_id vsx_common)

message("configuring            " ${module_id})


################################################################################
project (${module_id})

################################################################################
# CMAKE PACKAGES ###############################################################
################################################################################
find_package(DL REQUIRED)
find_package(Threads REQUIRED)

################################################################################
# INCLUDES #####################################################################
################################################################################

include_directories(
  ${CMAKE_SOURCE_DIR}/
  ${CMAKE_SOURCE_DIR}/lib/common/include
  ${CMAKE_SOURCE_DIR}/lib/compression/include
)

file(GLOB_RECURSE HEADER_FILES *.h)

################################################################################
# DEFINES
################################################################################

add_definitions(
 -DCMAKE_INSTALL_PREFIX="${CMAKE_INSTALL_PREFIX}"
)

if (VSXU_DEBUG EQUAL 1)
  add_definitions( -DVSXU_DEBUG )
endif (VSXU_DEBUG EQUAL 1)


################################################################################
# SOURCES ######################################################################
################################################################################

set(SOURCES
  third-party/mt/mt.cc
)

file(GLOB_RECURSE SOURCES_HEADERS include/*.h)
set(SOURCES ${SOURCES} ${SOURCES_HEADERS} )

file(GLOB_RECURSE SOURCES_HEADERS src/*.cpp)
set(SOURCES ${SOURCES} ${SOURCES_HEADERS} )

file(GLOB_RECURSE SOURCES_HEADERS include/*.cpp)
set(SOURCES ${SOURCES} ${SOURCES_HEADERS} )

if (NOT WIN32)
  set(SOURCES ${SOURCES} src/command/vsx_command_client_server.cpp)
endif()

################################################################################
# LINKAGE ######################################################################
################################################################################

if (VSXU_STATIC EQUAL 1)
  add_library(${module_id} STATIC ${SOURCES} ${HEADER_FILES})
else ()
  add_library(${module_id} SHARED ${SOURCES} ${HEADER_FILES})
endif ()

target_link_libraries(${module_id} ${CMAKE_THREAD_LIBS_INIT} vsx_compression)

install(TARGETS ${module_id} DESTINATION ${VSXU_INSTALL_LIB_DIR} COMPONENT common)

######################################################################################
# Install the Headers so as to install VSXu as a library
install (DIRECTORY "include/" DESTINATION ${CMAKE_INSTALL_PREFIX}/${VSXU_INSTALL_INCLUDE_DIR}/common COMPONENT Devel)
################################################################################

add_subdirectory(test)

=== lib/compression/CMakeLists.txt ===
set(module_id vsx_compression)

message("configuring            " ${module_id})


################################################################################
project (${module_id})

################################################################################
# CMAKE PACKAGES ###############################################################
################################################################################
find_package(DL REQUIRED)

################################################################################
# INCLUDES #####################################################################
################################################################################

include_directories(
  ${CMAKE_SOURCE_DIR}/
  ${CMAKE_SOURCE_DIR}/lib/common/include
  ${CMAKE_SOURCE_DIR}/lib/compression/include
)

file(GLOB_RECURSE HEADER_FILES *.h)

################################################################################
# DEFINES
################################################################################

add_definitions(
 -DCMAKE_INSTALL_PREFIX="${CMAKE_INSTALL_PREFIX}"
) 
if (MSVC)
else()
  add_definitions(-fno-strict-aliasing)
endif()

if (VSXU_DEBUG EQUAL 1)
  add_definitions( -DVSXU_DEBUG )
endif (VSXU_DEBUG EQUAL 1)


################################################################################
# SOURCES ######################################################################
################################################################################

set(SOURCES
  src/vsx_compression_lzma.cpp
  src/vsx_compression_lzma_old.cpp
  src/vsx_compression_lzham.cpp
)


add_definitions(-D_7ZIP_ST)
set(SOURCES_LZMA
  thirdparty/lzma-sdk/C/Alloc.c
  thirdparty/lzma-sdk/C/LzmaLib.c
  thirdparty/lzma-sdk/C/LzmaEnc.c
  thirdparty/lzma-sdk/C/LzmaDec.c
  thirdparty/lzma-sdk/C/LzFind.c
)


add_definitions(
  -DLZHAM_NO_THREADING=1
  -fno-strict-aliasing
)
include_directories(
  ${CMAKE_SOURCE_DIR}/lib/compression/thirdparty/lzham-sdk/include
  ${CMAKE_SOURCE_DIR}/lib/compression/thirdparty/lzham-sdk/lzhamcomp
  ${CMAKE_SOURCE_DIR}/lib/compression/thirdparty/lzham-sdk/lzhamdecomp
)
set(SOURCES_LZHAM
  thirdparty/lzham-sdk/lzhamlib/lzham_lib.cpp
  thirdparty/lzham-sdk/lzhamdecomp/lzham_assert.cpp
  thirdparty/lzham-sdk/lzhamdecomp/lzham_checksum.cpp
  thirdparty/lzham-sdk/lzhamdecomp/lzham_huffman_codes.cpp
  thirdparty/lzham-sdk/lzhamdecomp/lzham_lzdecompbase.cpp
  thirdparty/lzham-sdk/lzhamdecomp/lzham_lzdecomp.cpp
  thirdparty/lzham-sdk/lzhamdecomp/lzham_mem.cpp
  thirdparty/lzham-sdk/lzhamdecomp/lzham_platform.cpp
  thirdparty/lzham-sdk/lzhamdecomp/lzham_prefix_coding.cpp
  thirdparty/lzham-sdk/lzhamdecomp/lzham_symbol_codec.cpp
  #thirdparty/lzham-sdk/lzhamdecomp/lzham_timer.cpp
  thirdparty/lzham-sdk/lzhamdecomp/lzham_vector.cpp
  thirdparty/lzham-sdk/lzhamcomp/lzham_lzbase.cpp
  thirdparty/lzham-sdk/lzhamcomp/lzham_lzcomp.cpp
  thirdparty/lzham-sdk/lzhamcomp/lzham_lzcomp_internal.cpp
  thirdparty/lzham-sdk/lzhamcomp/lzham_lzcomp_state.cpp
  thirdparty/lzham-sdk/lzhamcomp/lzham_match_accel.cpp
)

if (WIN32)
    set(SOURCES_LZMA_OLD
        thirdparty/lzma-old/7zip/Common/InBuffer.cpp
        thirdparty/lzma-old/7zip/Common/OutBuffer.cpp
        thirdparty/lzma-old/7zip/Common/StreamUtils.cpp
        thirdparty/lzma-old/7zip/Compress/Branch/BranchX86.c
        thirdparty/lzma-old/7zip/Compress/LZMA/LZMADecoder.cpp
        thirdparty/lzma-old/7zip/Compress/LZMA/LZMAEncoder.cpp
        thirdparty/lzma-old/7zip/Compress/LZMA_C/LzmaDecode.c
        thirdparty/lzma-old/7zip/Compress/LZ/LZInWindow.cpp
        thirdparty/lzma-old/7zip/Compress/LZ/LZOutWindow.cpp
        thirdparty/lzma-old/7zip/Compress/RangeCoder/RangeCoderBit.cpp
        thirdparty/lzma-old/Common/Alloc_.cpp
        thirdparty/lzma-old/Common/CRC.cpp
        thirdparty/lzma-old/Common/String.cpp
        thirdparty/lzma-old/Common/StringConvert.cpp
        thirdparty/lzma-old/Common/StringToInt.cpp
        thirdparty/lzma-old/Common/Vector.cpp
        thirdparty/lzma-old/LzmaRam.cpp
        thirdparty/lzma-old/LzmaRamDecode.c
     )
else()
    set(SOURCES_LZMA_OLD
      thirdparty/lzma-old/Common/StringConvert.cpp
      thirdparty/lzma-old/Common/Alloc_.cpp
      thirdparty/lzma-old/Common/StringToInt.cpp
      thirdparty/lzma-old/Common/CRC.cpp
      thirdparty/lzma-old/Common/String.cpp
      thirdparty/lzma-old/Common/Vector.cpp
      thirdparty/lzma-old/Common/C_FileIO.cpp
      thirdparty/lzma-old/7zip/Common/OutBuffer.cpp
      thirdparty/lzma-old/7zip/Common/StreamUtils.cpp
      thirdparty/lzma-old/7zip/Common/InBuffer.cpp
      thirdparty/lzma-old/7zip/Compress/LZMA/LZMADecoder.cpp
      thirdparty/lzma-old/7zip/Compress/LZMA/LZMAEncoder.cpp
      thirdparty/lzma-old/7zip/Compress/LZ/LZOutWindow.cpp
      thirdparty/lzma-old/7zip/Compress/LZ/LZInWindow.cpp
      thirdparty/lzma-old/7zip/Compress/RangeCoder/RangeCoderBit.cpp
      thirdparty/lzma-old/LzmaRam.cpp
      thirdparty/lzma-old/7zip/Compress/LZMA_C/LzmaDecode.c
      thirdparty/lzma-old/7zip/Compress/Branch/BranchX86.c
      thirdparty/lzma-old/LzmaRamDecode.c
    )
endif()


################################################################################
# LINKAGE ######################################################################
################################################################################

if (VSXU_STATIC EQUAL 1)
  add_library(${module_id} STATIC ${SOURCES} ${SOURCES_LZMA} ${SOURCES_LZHAM} ${SOURCES_LZMA_OLD} ${HEADER_FILES})
else ()
  add_library(${module_id} SHARED ${SOURCES} ${SOURCES_LZMA} ${SOURCES_LZHAM} ${SOURCES_LZMA_OLD} ${HEADER_FILES})
endif ()

install(TARGETS ${module_id} DESTINATION ${VSXU_INSTALL_LIB_DIR} COMPONENT common)

######################################################################################
# Install the Headers so as to install VSXu as a library
install (DIRECTORY "include/" DESTINATION ${CMAKE_INSTALL_PREFIX}/${VSXU_INSTALL_INCLUDE_DIR}/application COMPONENT Devel)
################################################################################

if (WIN32)
  if (VSXU_BUILD_WINDOWS_32)
    install(FILES  DESTINATION ${VSXU_INSTALL_BIN_DIR} COMPONENT common)
  endif()
endif()

add_subdirectory(test)

=== lib/engine/CMakeLists.txt ===
set(module_id vsx_engine)

message("configuring            " ${module_id})


################################################################################
project (${module_id})

################################################################################
# CMAKE PACKAGES ###############################################################
################################################################################
find_package(DL REQUIRED)

################################################################################
# INCLUDES #####################################################################
################################################################################

include_directories(
  ${CMAKE_SOURCE_DIR}/
  ${CMAKE_SOURCE_DIR}/lib/common/include
  ${CMAKE_SOURCE_DIR}/lib/engine/include
  ${CMAKE_SOURCE_DIR}/lib/engine_graphics/include
  include
  src/log
  src/vsx_comp
  src
)

file(GLOB_RECURSE HEADER_FILES *.h)

################################################################################
# DEFINES
################################################################################
# - if you want an engine without OpenGL linkage, add -DVSX_NO_GL
################################################################################
# To debug the string library, enable this:
# add_definitions(
#  -DVSXS_DEBUG=1
# )

if (NOT MSVC)
  add_definitions( -Wno-parentheses ) # LZMA
  #add_definitions( -Wno-int-to-pointer-cast ) # vsx_filesystem::filesystemst WIN64
  add_definitions( -Wno-error -fpermissive ) # vsx_filesystem::filesystemst WIN64
endif()

add_definitions(
  # -DBUILDING_DLL
 -DVSXU_MODULE_TIMING
 -DVSXU_ARTISTE
 -DVSXU_DEVELOPER
 -DCMAKE_INSTALL_PREFIX="${CMAKE_INSTALL_PREFIX}"
 -DMOD_CNM=create_new_module
 -DMOD_DM=destroy_module
 -DMOD_GNM=get_num_modules
) 


if (VSXU_DEBUG EQUAL 1)
  add_definitions( -DVSXU_DEBUG )
endif (VSXU_DEBUG EQUAL 1)

################################################################################
# SOURCES ######################################################################
################################################################################

if(ENGINE_SCRIPTING)
# add gamemonkey source files here
  include_directories(
    src/core/scripting/game_monkey
    src/core/scripting/game_monkey/gm
  )
  set(GAME_MONKEY 
    src/core/scripting/game_monkey/binds/gmStringLib.cpp
    src/core/scripting/game_monkey/binds/gmGCRootUtil.cpp
    src/core/scripting/game_monkey/binds/gmHelpers.cpp
    src/core/scripting/game_monkey/binds/gmVector3Lib.cpp
    src/core/scripting/game_monkey/binds/gmGCRoot.cpp
    src/core/scripting/game_monkey/binds/gmArrayLib.cpp
    src/core/scripting/game_monkey/binds/gmCall.cpp
    src/core/scripting/game_monkey/binds/gmMathLib.cpp
    src/core/scripting/game_monkey/gm/gmMachineLib.cpp
    src/core/scripting/game_monkey/gm/gmStreamBuffer.cpp
    src/core/scripting/game_monkey/gm/gmParser.cpp
    src/core/scripting/game_monkey/gm/gmHash.cpp
    src/core/scripting/game_monkey/gm/gmCodeGen.cpp
    src/core/scripting/game_monkey/gm/gmArraySimple.cpp
    src/core/scripting/game_monkey/gm/gmThread.cpp
    src/core/scripting/game_monkey/gm/gmLog.cpp
    src/core/scripting/game_monkey/gm/gmMemFixedSet.cpp
    #src/core/scripting/game_monkey/gm/gmDebugger.cpp
    src/core/scripting/game_monkey/gm/gmStringObject.cpp
    src/core/scripting/game_monkey/gm/gmCodeTree.cpp
    src/core/scripting/game_monkey/gm/gmStream.cpp
    src/core/scripting/game_monkey/gm/gmVariable.cpp
    src/core/scripting/game_monkey/gm/gmParser.cpp.h
    src/core/scripting/game_monkey/gm/gmCodeGenHooks.cpp
    src/core/scripting/game_monkey/gm/gmDebug.cpp
    src/core/scripting/game_monkey/gm/gmIncGC.cpp
    src/core/scripting/game_monkey/gm/gmLibHooks.cpp
    src/core/scripting/game_monkey/gm/gmMem.cpp
    src/core/scripting/game_monkey/gm/gmTableObject.cpp
    src/core/scripting/game_monkey/gm/gmMachine.cpp
    src/core/scripting/game_monkey/gm/gmMemChain.cpp
    src/core/scripting/game_monkey/gm/gmUtil.cpp
    src/core/scripting/game_monkey/gm/gmFunctionObject.cpp
    src/core/scripting/game_monkey/gm/gmCrc.cpp
    src/core/scripting/game_monkey/gm/gmByteCode.cpp
    src/core/scripting/game_monkey/gm/gmListDouble.cpp
    src/core/scripting/game_monkey/gm/gmOperators.cpp
    src/core/scripting/game_monkey/gm/gmMemFixed.cpp
    src/core/scripting/game_monkey/gm/gmByteCodeGen.cpp
    src/core/scripting/game_monkey/gm/gmUserObject.cpp
    src/core/scripting/game_monkey/gm/gmScanner.cpp
    src/core/scripting/vsx_comp_vsxl.cpp
    src/core/scripting/vsx_param_vsxl.cpp
  )
else(ENGINE_SCRIPTING)
  set(GAME_MONKEY "")
  add_definitions(
    -DVSXE_NO_GM
  )
endif(ENGINE_SCRIPTING)

set(SOURCES
  src/vsx_engine.cpp
  src/vsx_engine_abs.cpp
  src/vsx_sequence_pool.cpp
  src/vsx_param_abstraction.cpp
  src/vsx_comp_channel.cpp
  src/vsx_param_interpolation.cpp
  src/vsx_comp/vsx_comp.cpp
  src/vsx_param_sequence.cpp
  src/vsx_master_sequencer/vsx_master_sequence_channel.cpp
  src/vsx_param_sequence_list.cpp
  src/vsx_module_list/vsx_module_list_factory.cpp
  src/vsx_module_list/vsx_dlopen.cpp
  src/vsx_param.cpp
)

################################################################################
# LINKAGE ######################################################################
################################################################################

if (VSXU_STATIC EQUAL 1)

  #static build
  add_library(${module_id} STATIC ${SOURCES} ${HEADER_FILES} ${GAME_MONKEY})
  target_link_libraries(${module_id} plugins)

else ()

  #dynamic build
  add_library(${module_id} SHARED ${SOURCES} ${HEADER_FILES} ${GAME_MONKEY})
endif ()

if (UNIX)
  install(TARGETS ${module_id} DESTINATION ${VSXU_INSTALL_LIB_DIR} COMPONENT engine)

######################################################################################
# Install the Headers so as to install VSXu as a library
  install (DIRECTORY "include/" DESTINATION ${CMAKE_INSTALL_PREFIX}/${VSXU_INSTALL_INCLUDE_DIR}/engine COMPONENT Devel)
################################################################################
endif()

target_link_libraries(${module_id}
  ${DL_LIBRARY}
  vsx_common
)

=== lib/engine_graphics/CMakeLists.txt ===
set(module_id vsx_engine_graphics)

message("configuring            " ${module_id})


project (${module_id})

include(${CMAKE_SOURCE_DIR}/cmake/CMakeFindLib.txt)

################################################################################
# CMAKE PACKAGES ###############################################################
################################################################################
find_package(Threads REQUIRED)
find_package(OpenGL REQUIRED)


################################################################################
# INCLUDES #####################################################################
################################################################################

include_directories(
  ${OPENGL_INCLUDE_DIR}
  ${CMAKE_SOURCE_DIR}/
  ${CMAKE_SOURCE_DIR}/lib/common/include
  ${CMAKE_SOURCE_DIR}/lib/engine_graphics/include
)

################################################################################
# DEFINITIONS ##################################################################
################################################################################

add_definitions(
   # -DBUILDING_DLL
 -DVSX_FONT_NO_FT
 -DVSXU_DEVELOPER
 -DCMAKE_INSTALL_PREFIX="${CMAKE_INSTALL_PREFIX}"
)

if (VSXU_STATIC EQUAL 1)
  add_definitions(-DVSXU_STATIC)
  add_definitions(-DGLEW_STATIC)
endif()


if (VSXU_DEBUG EQUAL 1)
  add_definitions( -DVSXU_DEBUG -DDEBUG )
endif (VSXU_DEBUG EQUAL 1)

################################################################################
# SOURCES ######################################################################
################################################################################

file(GLOB_RECURSE SOURCES include/*.h)
file(GLOB_RECURSE SOURCES_CPP include/*.cpp)
set(SOURCES ${SOURCES} ${SOURCES_CPP})
file(GLOB_RECURSE SOURCES_CPP src/*.cpp)
set(SOURCES ${SOURCES} ${SOURCES_CPP})

#ftgl
include_directories(
thirdparty/ftgl
thirdparty/ftgl/src
)


set( SOURCES_FREETYPE
    thirdparty/freetype2/src/autofit/autofit.c
    thirdparty/freetype2/src/base/ftbase.c
    thirdparty/freetype2/src/base/ftbbox.c
    thirdparty/freetype2/src/base/ftbdf.c
    thirdparty/freetype2/src/base/ftbitmap.c
    thirdparty/freetype2/src/base/ftcid.c
    thirdparty/freetype2/src/base/ftdebug.c
    thirdparty/freetype2/src/base/ftfstype.c
    thirdparty/freetype2/src/base/ftgasp.c
    thirdparty/freetype2/src/base/ftglyph.c
    thirdparty/freetype2/src/base/ftgxval.c
    thirdparty/freetype2/src/base/ftinit.c
    thirdparty/freetype2/src/base/ftlcdfil.c
    thirdparty/freetype2/src/base/ftmm.c
    thirdparty/freetype2/src/base/ftotval.c
    thirdparty/freetype2/src/base/ftpatent.c
    thirdparty/freetype2/src/base/ftpfr.c
    thirdparty/freetype2/src/base/ftstroke.c
    thirdparty/freetype2/src/base/ftsynth.c
    thirdparty/freetype2/src/base/ftsystem.c
    thirdparty/freetype2/src/base/fttype1.c
    thirdparty/freetype2/src/base/ftwinfnt.c
    thirdparty/freetype2/src/bdf/bdf.c
    thirdparty/freetype2/src/cff/cff.c
    thirdparty/freetype2/src/cid/type1cid.c
    thirdparty/freetype2/src/pcf/pcf.c
    thirdparty/freetype2/src/pfr/pfr.c
    thirdparty/freetype2/src/psaux/psaux.c
    thirdparty/freetype2/src/pshinter/pshinter.c
    thirdparty/freetype2/src/psnames/psnames.c
    thirdparty/freetype2/src/raster/raster.c
    thirdparty/freetype2/src/sfnt/sfnt.c
    thirdparty/freetype2/src/smooth/smooth.c
    thirdparty/freetype2/src/truetype/truetype.c
    thirdparty/freetype2/src/type1/type1.c
    thirdparty/freetype2/src/type42/type42.c
    thirdparty/freetype2/src/winfonts/winfnt.c
)

set(SOURCES_FTGL
    thirdparty/ftgl/src/FTBuffer.cpp
    thirdparty/ftgl/src/FTCharmap.cpp
    thirdparty/ftgl/src/FTCleanup.cpp
    thirdparty/ftgl/src/FTContour.cpp
    thirdparty/ftgl/src/FTFace.cpp
    thirdparty/ftgl/src/FTFont/FTBitmapFont.cpp
    thirdparty/ftgl/src/FTFont/FTBufferFont.cpp
    thirdparty/ftgl/src/FTFont/FTExtrudeFont.cpp
    thirdparty/ftgl/src/FTFont/FTFont.cpp
    thirdparty/ftgl/src/FTFont/FTFontGlue.cpp
    thirdparty/ftgl/src/FTFont/FTOutlineFont.cpp
    thirdparty/ftgl/src/FTFont/FTPixmapFont.cpp
    thirdparty/ftgl/src/FTFont/FTPolygonFont.cpp
    thirdparty/ftgl/src/FTFont/FTTextureFont.cpp
    thirdparty/ftgl/src/FTFont/FTTriangleExtractorFont.cpp
    thirdparty/ftgl/src/FTGL.cpp
    thirdparty/ftgl/src/FTGlyph/FTBitmapGlyph.cpp
    thirdparty/ftgl/src/FTGlyph/FTBufferGlyph.cpp
    thirdparty/ftgl/src/FTGlyph/FTExtrudeGlyph.cpp
    thirdparty/ftgl/src/FTGlyph/FTGLGlyph.cpp
    thirdparty/ftgl/src/FTGlyph/FTGlyphGlue.cpp
    thirdparty/ftgl/src/FTGlyph/FTOutlineGlyph.cpp
    thirdparty/ftgl/src/FTGlyph/FTPixmapGlyph.cpp
    thirdparty/ftgl/src/FTGlyph/FTPolygonGlyph.cpp
    thirdparty/ftgl/src/FTGlyph/FTTextureGlyph.cpp
    thirdparty/ftgl/src/FTGlyph/FTTriangleExtractorGlyph.cpp
    thirdparty/ftgl/src/FTGlyphContainer.cpp
    thirdparty/ftgl/src/FTLayout/FTLayout.cpp
    thirdparty/ftgl/src/FTLayout/FTLayoutGlue.cpp
    thirdparty/ftgl/src/FTLayout/FTSimpleLayout.cpp
    thirdparty/ftgl/src/FTLibrary.cpp
    thirdparty/ftgl/src/FTPoint.cpp
    thirdparty/ftgl/src/FTSize.cpp
    thirdparty/ftgl/src/FTVectoriser.cpp
)

if (WIN32)
  include_directories( thirdparty/freetype2/include )
  include_directories( thirdparty/freetype2/include/freetype )
  include_directories( thirdparty/freetype2/include/freetype/config )
  add_definitions( -DFTGL_LIBRARY_STATIC -DFT2_BUILD_LIBRARY)
  set(SOURCES ${SOURCES} ${SOURCES_FREETYPE} thirdparty/glew-1.7.0/src/glew.c)
endif()

#perlin
include_directories(
thirdparty/perlin
)
set(SOURCES_PERLIN
thirdparty/perlin/perlin.cpp
)

#lodepng
include_directories(
    thirdparty/lodepng
)
set(SOURCES_LODEPNG
    thirdparty/lodepng/lodepng.cpp
)

#jpeg
include_directories(
thirdparty/mini-jpeg
)


file(GLOB_RECURSE HEADER_FILES *.h)


if (VSXU_STATIC EQUAL 1)
  #static build
  add_library(${module_id} STATIC ${SOURCES} ${SOURCES_FTGL} ${SOURCES_PERLIN} ${HEADER_FILES} ${SOURCES_LODEPNG})
else ()
  add_library(${module_id} SHARED ${SOURCES} ${SOURCES_FTGL} ${SOURCES_PERLIN} ${HEADER_FILES} ${SOURCES_LODEPNG})
endif()

if (UNIX)
install(TARGETS ${module_id} DESTINATION ${VSXU_INSTALL_LIB_DIR} COMPONENT engine)
endif()

######################################################################################
# Install the Headers so as to install VSXu as a library
if (UNIX OR VSXU_WINDOWS_LIB_BUILD)
  install (DIRECTORY "include/" DESTINATION ${CMAKE_INSTALL_PREFIX}/${VSXU_INSTALL_INCLUDE_DIR}/engine_graphics COMPONENT Devel)
  install(FILES ${CMAKE_SOURCE_DIR}/share/icons/vsxu.xpm DESTINATION ${CMAKE_INSTALL_PREFIX}/share/pixmaps/)
  install(FILES ${CMAKE_SOURCE_DIR}/share/icons/hicolor/16x16/apps/vsxu.png DESTINATION ${CMAKE_INSTALL_PREFIX}/share/pixmaps/hicolor/apps/16x16)
  install(FILES ${CMAKE_SOURCE_DIR}/share/icons/hicolor/22x22/apps/vsxu.png DESTINATION ${CMAKE_INSTALL_PREFIX}/share/pixmaps/hicolor/apps/22x22)
  install(FILES ${CMAKE_SOURCE_DIR}/share/icons/hicolor/24x24/apps/vsxu.png DESTINATION ${CMAKE_INSTALL_PREFIX}/share/pixmaps/hicolor/apps/24x24)
  install(FILES ${CMAKE_SOURCE_DIR}/share/icons/hicolor/32x32/apps/vsxu.png DESTINATION ${CMAKE_INSTALL_PREFIX}/share/pixmaps/hicolor/apps/32x32)
  install(FILES ${CMAKE_SOURCE_DIR}/share/icons/hicolor/36x36/apps/vsxu.png DESTINATION ${CMAKE_INSTALL_PREFIX}/share/pixmaps/hicolor/apps/36x36)
  install(FILES ${CMAKE_SOURCE_DIR}/share/icons/hicolor/48x48/apps/vsxu.png DESTINATION ${CMAKE_INSTALL_PREFIX}/share/pixmaps/hicolor/apps/48x48)
  install(FILES ${CMAKE_SOURCE_DIR}/share/icons/hicolor/64x64/apps/vsxu.png DESTINATION ${CMAKE_INSTALL_PREFIX}/share/pixmaps/hicolor/apps/64x64)
  install(FILES ${CMAKE_SOURCE_DIR}/share/icons/hicolor/72x72/apps/vsxu.png DESTINATION ${CMAKE_INSTALL_PREFIX}/share/pixmaps/hicolor/apps/72x72)
  install(FILES ${CMAKE_SOURCE_DIR}/share/icons/hicolor/96x96/apps/vsxu.png DESTINATION ${CMAKE_INSTALL_PREFIX}/share/pixmaps/hicolor/apps/96x96)
  install(FILES ${CMAKE_SOURCE_DIR}/share/icons/hicolor/128x128/apps/vsxu.png DESTINATION ${CMAKE_INSTALL_PREFIX}/share/pixmaps/hicolor/apps/128x128)
  install(FILES ${CMAKE_SOURCE_DIR}/share/icons/hicolor/192x192/apps/vsxu.png DESTINATION ${CMAKE_INSTALL_PREFIX}/share/pixmaps/hicolor/apps/192x192)
  install(FILES ${CMAKE_SOURCE_DIR}/share/icons/hicolor/256x256/apps/vsxu.png DESTINATION ${CMAKE_INSTALL_PREFIX}/share/pixmaps/hicolor/apps/256x256)
  install(FILES ${CMAKE_SOURCE_DIR}/share/icons/hicolor/512x512/apps/vsxu.png DESTINATION ${CMAKE_INSTALL_PREFIX}/share/pixmaps/hicolor/apps/512x512)
endif()
################################################################################


if(WIN32)
  target_link_libraries(${module_id} gdi32)
  target_link_libraries(${module_id} -static)
endif()


target_link_libraries(
  ${module_id}
  vsx_engine
  ${GLEW_LIBRARIES}
  ${FTGL_LIBRARY}
  ${FREETYPE_LIBRARIES}
  ${CMAKE_THREAD_LIBS_INIT}
  ${OPENGL_LIBRARIES}
  ${PNG_LIBRARIES}
  ${ZLIB_LIBRARIES}
)

=== lib/widget/CMakeLists.txt ===
set(module_id vsx_widget)

message("configuring            " ${module_id})

################################################################################
project (${module_id})


include(${CMAKE_SOURCE_DIR}/cmake/CMakeFindLib.txt)

################################################################################
# CMAKE PACKAGES ###############################################################
################################################################################
find_package(Threads REQUIRED)
find_package(OpenGL REQUIRED)

################################################################################
# INCLUDES #####################################################################
################################################################################

include_directories(
  ${CMAKE_SOURCE_DIR}/
  ${CMAKE_SOURCE_DIR}/lib/common/include
  ${CMAKE_SOURCE_DIR}/lib/application/include
  ${CMAKE_SOURCE_DIR}/lib/engine/include
  ${CMAKE_SOURCE_DIR}/lib/engine_graphics/include
  include
  include/widgets
)



################################################################################
# DEFINES
################################################################################
# - if you want an engine without OpenGL linkage, add -DVSX_NO_GL
################################################################################

add_definitions(
 -DCMAKE_INSTALL_PREFIX="${CMAKE_INSTALL_PREFIX}"
)
if (MSVC)
else()
  add_definitions(
   -Werror=float-equal
  )
endif()

if (VSXU_DEBUG EQUAL 1)
  add_definitions( -DVSXU_DEBUG )
endif (VSXU_DEBUG EQUAL 1)

if (VSXU_STATIC EQUAL 1)
  add_definitions(-DVSXU_STATIC)
  add_definitions(-DGLEW_STATIC)
endif()


################################################################################
# SOURCES ######################################################################
################################################################################

file(GLOB_RECURSE SOURCES include/*.h)
file(GLOB_RECURSE SOURCES_CPP include/*.cpp)
set(SOURCES ${SOURCES} ${SOURCES_CPP})
file(GLOB_RECURSE SOURCES_CPP src/*.cpp)
set(SOURCES ${SOURCES} ${SOURCES_CPP})

################################################################################
# LINKAGE ######################################################################
################################################################################

if (VSXU_STATIC EQUAL 1)

  #static build
  add_library(${module_id} STATIC ${SOURCES})

else ()

  #dynamic build
  add_library(${module_id} SHARED ${SOURCES})

endif ()


if (UNIX)
  install(TARGETS ${module_id} DESTINATION ${VSXU_INSTALL_LIB_DIR} COMPONENT widget)

  ######################################################################################
  # Install the Headers so as to install VSXu as a library
  install (DIRECTORY "include/" DESTINATION ${CMAKE_INSTALL_PREFIX}/${VSXU_INSTALL_INCLUDE_DIR}/widget COMPONENT Devel)
  ################################################################################
endif()

if(UNIX)
target_link_libraries(
  ${module_id}
  ${JPEG_LIBRARIES}
  ${PNG_LIBRARIES}
  ${ZLIB_LIBRARIES}
  ${GLFW_LIBRARIES}
  ${GLEW_LIBRARIES}
  vsx_engine
  ${OPENGL_LIBRARIES}
  ${CMAKE_THREAD_LIBS_INIT}
)
endif(UNIX)

if(WIN32)
  target_link_libraries(
    ${module_id}
    ${JPEG_LIBRARIES}
    ${PNG_LIBRARIES}
    ${ZLIB_LIBRARIES}
    ${GLFW_LIBRARIES}
    vsx_engine
    vsx_engine_graphics
    ${GLEW_LIBRARIES}
    ${OPENGL_LIBRARIES}
    vsx_engine_graphics
  )
endif(WIN32)

=== programs/artiste/CMakeLists.txt ===
set(module_id vsxu_artiste)

message("configuring            " ${module_id})

include(${CMAKE_SOURCE_DIR}/cmake/CMakeFindLib.txt)
include(${CMAKE_SOURCE_DIR}/cmake/CMakeVSXuGfxLib.txt)

################################################################################
project (${module_id})

################################################################################
# CMAKE PACKAGES ###############################################################
################################################################################
find_package(Threads REQUIRED)
find_package(OpenGL REQUIRED)

################################################################################
# INCLUDES #####################################################################
################################################################################

include_directories(
  ${OPENGL_INCLUDE_DIR}
  ${CMAKE_SOURCE_DIR}
  ${CMAKE_SOURCE_DIR}/lib/application/include
  ${CMAKE_SOURCE_DIR}/lib/common/include
  ${CMAKE_SOURCE_DIR}/lib/engine/include
  ${CMAKE_SOURCE_DIR}/lib/engine_graphics/include
  ${CMAKE_SOURCE_DIR}/lib/widget/include
  ${CMAKE_SOURCE_DIR}/programs/artiste/src
  ${CMAKE_SOURCE_DIR}/programs/artiste/src/vsx_widget
  ${CMAKE_SOURCE_DIR}/programs/artiste/include
)

################################################################################
# DEFINES ######################################################################
################################################################################

if(UNIX)
  add_definitions(-D_LINUX)
endif(UNIX)

if(VSXU_DEBUG)
  add_definitions( -DDEBUG )
  add_definitions( -DVSXU_DEBUG )
endif(VSXU_DEBUG)


add_definitions(
 -DVSXU_ARTISTE
 -DCMAKE_INSTALL_PREFIX="${CMAKE_INSTALL_PREFIX}"
)

if (VSXU_STATIC EQUAL 1)
  add_definitions(-DVSXU_STATIC)
  add_definitions(-DGLEW_STATIC)
  add_definitions(-DFTGL_LIBRARY_STATIC)
endif()



################################################################################
# SOURCES ######################################################################
################################################################################

set(SOURCES
  src/log/vsx_log_a.cpp
  src/vsx_widget/server/vsx_widget_comp.cpp
  src/vsx_widget/server/vsx_widget_connector_bezier.cpp
  src/vsx_widget/server/vsx_widget_anchor.cpp
  src/vsx_widget/server/vsx_widget_server.cpp
  src/vsx_widget/controllers/vsx_widget_controller_ab.cpp
  src/vsx_widget/controllers/vsx_widget_controller_base.cpp
  src/vsx_widget/controllers/vsx_widget_controller_channel.cpp
  src/vsx_widget/controllers/vsx_widget_controller_color.cpp
  src/vsx_widget/controllers/vsx_widget_controller_dialog.cpp
  src/vsx_widget/controllers/vsx_widget_controller_editor.cpp
  src/vsx_widget/controllers/vsx_widget_controller_knob.cpp
  src/vsx_widget/controllers/vsx_widget_controller_mixer.cpp
  src/vsx_widget/controllers/vsx_widget_controller_pad.cpp
  src/vsx_widget/controllers/vsx_widget_controller_seq.cpp
  src/vsx_widget/controllers/vsx_widget_controller_slider.cpp
  src/vsx_widget/helpers/vsx_widget_preview.cpp
  src/vsx_widget/helpers/vsx_widget_assistant.cpp
  src/vsx_widget/helpers/vsx_widget_object_inspector.cpp
  src/vsx_widget/helpers/vsx_widget_console.cpp
  src/vsx_widget/helpers/vsx_widget_note.cpp
  src/vsx_widget/sequencer/vsx_widget_master_sequencer.cpp
  src/vsx_widget/sequencer/vsx_widget_sequence_channel.cpp
  src/vsx_widget/sequencer/vsx_widget_sequence_editor.cpp
  src/vsx_widget/sequencer/pool_manager/vsx_widget_seq_pool.cpp
  src/vsx_widget/sequencer/vsx_widget_timeline.cpp
  src/vsx_widget/arcball/arcball.cpp
  src/vsx_widget/module_choosers/vsx_widget_module_chooser.cpp
  src/vsx_widget/module_choosers/vsx_widget_module_chooser_list.cpp
  src/artiste_main.cpp
)

# Solve the problem with DPI scaling
# since we want our own rc file
if(WIN32)
    set(CMAKE_EXE_LINKER_FLAGS "/MANIFEST:NO")
    set(SOURCES ${SOURCES} artiste.rc)
endif()

file(GLOB_RECURSE HEADER_FILES *.h)


################################################################################
# LINK #########################################################################
################################################################################

add_executable(${module_id} ${SOURCES} ${HEADER_FILES})

include(${CMAKE_SOURCE_DIR}/cmake_suffix.txt)

if(UNIX)
  if (VSXU_STATIC)
    target_link_libraries(
      ${module_id}
      ${CMAKE_THREAD_LIBS_INIT}
      ${GLEW_LIBRARIES}
      ${OPENGL_LIBRARIES}
      vsx_application
      ${VSXU_GFX_LIB_LIBS}
      vsx_common
      vsx_compression
      vsx_engine
      vsx_engine_graphics
      plugins
      rt
      vsx_common
      vsx_compression
      vsx_engine
      vsx_engine_graphics
      plugins
      vsx_widget
    )
  else()
    target_link_libraries(
      ${module_id}
      ${CMAKE_THREAD_LIBS_INIT}
      ${GLEW_LIBRARIES}
      ${OPENGL_LIBRARIES}
      vsx_application
      ${VSXU_GFX_LIB_LIBS}
      vsx_common
      vsx_compression
      vsx_engine
      vsx_engine_graphics
      rt
      vsx_widget
      vsx_common
      vsx_compression
      vsx_engine
      vsx_engine_graphics
    )
  endif()
endif(UNIX)


if(WIN32)
  target_link_libraries(
    ${module_id}
    vsx_application
    ${VSXU_GFX_LIB_LIBS}
    wsock32
    ws2_32
    vsx_engine_graphics
    vsx_engine
    vsx_common
    vsx_compression
    vsx_widget
    gdi32
    ${OPENGL_LIBRARIES}
    ${JPEG_LIBRARIES}
    ${PNG_LIBRARIES}
    ${ZLIB_LIBRARIES}
    -lstdc++
    ${CMAKE_THREAD_LIBS_INIT}
    ${FREETYPE_LIBRARIES}
  )
endif(WIN32)


################################################################################
## INSTALL #####################################################################
################################################################################

install(TARGETS ${module_id} DESTINATION ${VSXU_INSTALL_BIN_DIR} COMPONENT artiste)
install(
  DIRECTORY
    ${CMAKE_SOURCE_DIR}/share/visuals_faders
    ${CMAKE_SOURCE_DIR}/share/visuals_player
    ${CMAKE_SOURCE_DIR}/share/font
    ${CMAKE_SOURCE_DIR}/share/gfx/vsxu_luna
    ${CMAKE_SOURCE_DIR}/share/example-macros
    ${CMAKE_SOURCE_DIR}/share/example-prods
    ${CMAKE_SOURCE_DIR}/share/example-resources
    ${CMAKE_SOURCE_DIR}/share/example-states
    ${CMAKE_SOURCE_DIR}/share/example-faders
    ${CMAKE_SOURCE_DIR}/share/doc
    ${CMAKE_SOURCE_DIR}/share/example-visuals
  DESTINATION
    ${VSXU_INSTALL_SHARE_DIR}
  COMPONENT
    artiste
)

install(
  DIRECTORY
    ${CMAKE_SOURCE_DIR}/share/gfx/vsxu_luna
  DESTINATION
    ${VSXU_INSTALL_SHARE_DIR}/gfx
  COMPONENT
    artiste
)

install(
  FILES
    ${CMAKE_SOURCE_DIR}/share/gfx/vsxu_logo.dds
    ${CMAKE_SOURCE_DIR}/share/gfx/vsxu_logo_bkg.dds
    ${CMAKE_SOURCE_DIR}/share/gfx/assistant_luna.dds
    ${CMAKE_SOURCE_DIR}/share/vsxu.conf
  DESTINATION
    ${VSXU_INSTALL_SHARE_DIR}/gfx
  COMPONENT
    artiste
)

install(
  FILES
    ${CMAKE_SOURCE_DIR}/share/vsxu.conf
  DESTINATION
    ${VSXU_INSTALL_SHARE_DIR}
  COMPONENT
    artiste
)

IF (${CMAKE_SYSTEM_NAME} MATCHES "Linux")

  CONFIGURE_FILE (${CMAKE_CURRENT_SOURCE_DIR}/vsxu-artiste-fullscreen.desktop.in
                  ${CMAKE_CURRENT_BINARY_DIR}/vsxu-artiste-fullscreen.desktop
                  @ONLY)
  CONFIGURE_FILE (${CMAKE_CURRENT_SOURCE_DIR}/vsxu-artiste.desktop.in
                  ${CMAKE_CURRENT_BINARY_DIR}/vsxu-artiste.desktop
                  @ONLY)

  INSTALL (FILES ${CMAKE_CURRENT_BINARY_DIR}/vsxu-artiste-fullscreen.desktop
                 ${CMAKE_CURRENT_BINARY_DIR}/vsxu-artiste.desktop
           DESTINATION ${CMAKE_INSTALL_PREFIX}/share/applications/)
ENDIF (${CMAKE_SYSTEM_NAME} MATCHES "Linux")

=== programs/launcher/CMakeLists.txt ===
set(module_id vsxu_launcher)

message("configuring            " ${module_id})


################################################################################
project (${module_id})

include(${CMAKE_SOURCE_DIR}/cmake/CMakeFindLib.txt)
include(${CMAKE_SOURCE_DIR}/cmake/CMakeVSXuGfxLib.txt)

################################################################################
# CMAKE PACKAGES ###############################################################
################################################################################
find_package(OpenGL REQUIRED)


################################################################################
# INCLUDES #####################################################################
################################################################################

include_directories(
  ${OPENGL_INCLUDE_DIR}
  ${CMAKE_CURRENT_LIST_DIR}/src
  ${CMAKE_SOURCE_DIR}/
  ${CMAKE_SOURCE_DIR}/lib/application/include
  ${CMAKE_SOURCE_DIR}/lib/common/include
  ${CMAKE_SOURCE_DIR}/lib/engine/include
  ${CMAKE_SOURCE_DIR}/lib/engine_graphics/include
  ${CMAKE_SOURCE_DIR}/lib/widget/include
  ${CMAKE_SOURCE_DIR}/programs/profiler/src
)

################################################################################
# DEFINES ######################################################################
################################################################################

if(UNIX)
  add_definitions(-D_LINUX)
endif(UNIX)

if(VSXU_DEBUG)
  add_definitions( -DDEBUG )
  add_definitions( -DVSXU_DEBUG )
endif(VSXU_DEBUG)



add_definitions(
 -DCMAKE_INSTALL_PREFIX="${CMAKE_INSTALL_PREFIX}"
)


################################################################################
# SOURCES ######################################################################
################################################################################

set(SOURCES
  src/launcher_main.cpp
)

file(GLOB GLOB_RESULT src/*.cpp)
set(SOURCES ${SOURCES} ${GLOB_RESULT})
if (NOT VSXU_STATIC EQUAL 1)
  set(SOURCES ${SOURCES} src/RtAudio/RtAudio.cpp)
endif()

# Solve the problem with DPI scaling
# since we want our own rc file
if(WIN32)
    set(CMAKE_EXE_LINKER_FLAGS "/MANIFEST:NO")
    set(SOURCES ${SOURCES} launcher.rc)
endif()

file(GLOB_RECURSE HEADER_FILES *.h)


set(AUDIO_LIBRARIES "")
set(WITH_MIDI FALSE)

if (WIN32)
    add_definitions(
      -D__WINDOWS_DS__
      -D_MBCS
    )
endif()

if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
  find_package(PULSEAUDIO)
  if(PULSEAUDIO_FOUND)
    set( DEFINITIONS -D__LINUX_PULSE__)
    set( INCLUDE_DIRS ${PULSEAUDIO_INCLUDE_DIRS})
    set( AUDIO_LIBRARIES ${PULSEAUDIO_LIBRARY} ${PULSEAUDIO_SIMPLE_LIBRARY})
  endif(PULSEAUDIO_FOUND)

  find_package(JACK)
  if(JACK_FOUND)
    set( DEFINITIONS ${DEFINITIONS} -D__LINUX_JACK__)
    set( WITH_MIDI TRUE )
    set( INCLUDE_DIRS ${INCLUDE_DIRS} ${JACK_INCLUDE_DIRS})
    set( AUDIO_LIBRARIES ${AUDIO_LIBRARIES} ${JACK_LIBRARY} )
  endif(JACK_FOUND)

  find_package(ALSA)
  if(ALSA_FOUND)
    set( DEFINITIONS ${DEFINITIONS} -D__LINUX_ALSA__)
    set( DEFINITIONS ${DEFINITIONS} -DWITH_MIDI )
    set( WITH_MIDI TRUE )
    set( INCLUDE_DIRS ${INCLUDE_DIRS} ${ALSA_INCLUDE_DIRS})
    set( AUDIO_LIBRARIES ${AUDIO_LIBRARIES} ${ALSA_LIBRARY} )
  endif(ALSA_FOUND)
endif(${CMAKE_SYSTEM_NAME} MATCHES "Linux")


if(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
  find_library(COREAUDIO_LIBRARY CoreAudio)
  if(COREAUDIO_LIBRARY_FOUND)
    set( DEFINITIONS -D__MACOSX_CORE__)
    set( DEFINITIONS -D__OS_MACOSX__)
    set( AUDIO_LIBRARIES ${AUDIO_LIBRARIES} ${COREAUDIO_LIBRARY})
  endif(COREAUDIO_LIBRARY_FOUND)
endif(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")


if(${CMAKE_SYSTEM_NAME} MATCHES "Windows")
  set( DEFINITIONS -D__WINDOWS_DS__ -D__WINDOWS_MM__ -D__WINDOWS_WASAPI__=1)
  set( AUDIO_LIBRARIES ${AUDIO_LIBRARIES} winmm dsound)
endif(${CMAKE_SYSTEM_NAME} MATCHES "Windows")

message(${AUDIO_LIBRARIES})
################################################################################
# LINK #########################################################################
################################################################################

add_executable(${module_id} ${SOURCES} ${HEADER_FILES} )
add_definitions(${DEFINITIONS})
include(${CMAKE_SOURCE_DIR}/cmake_suffix.txt)

if(UNIX)
  target_link_libraries(
    ${module_id}
    ${CMAKE_THREAD_LIBS_INIT}
    ${GLEW_LIBRARIES}
    ${OPENGL_LIBRARIES}
    ${PNG_LIBRARIES}
    ${JPEG_LIBRARIES}
    vsx_common
    vsx_compression
    vsx_engine
    vsx_engine_graphics
    vsx_widget
    vsx_engine_graphics
    vsx_application
    ${VSXU_GFX_LIB_LIBS}
    ${AUDIO_LIBRARIES}
    rt
    
  )
endif(UNIX)

if (WIN32)
  target_link_libraries(
    ${module_id}
    ${CMAKE_THREAD_LIBS_INIT}
    ${GLEW_LIBRARIES}
    ${PNG_LIBRARIES}
    ${JPEG_LIBRARIES}
    vsx_application
    vsx_common
    vsx_compression
    vsx_engine
    vsx_engine_graphics
    vsx_widget
    vsx_application
    ${VSXU_GFX_LIB_LIBS}
    ${AUDIO_LIBRARIES}
  )
endif()


################################################################################
## INSTALL #####################################################################
################################################################################

install(TARGETS ${module_id} DESTINATION ${VSXU_INSTALL_BIN_DIR} COMPONENT launcher)

######################################################################################
# Install the Headers so as to install VSXu as a library
if (UNIX OR VSXU_WINDOWS_LIB_BUILD)
  file(GLOB HEADERS "include/*.h")
  install (FILES ${HEADERS} DESTINATION ${CMAKE_INSTALL_PREFIX}/${VSXU_INSTALL_INCLUDE_DIR}/profiler COMPONENT Devel)
endif()
################################################################################

=== programs/player/CMakeLists.txt ===
set(module_id vsxu_player)

message("configuring            " ${module_id})


################################################################################
project (${module_id})

include(${CMAKE_SOURCE_DIR}/cmake/CMakeFindLib.txt)
include(${CMAKE_SOURCE_DIR}/cmake/CMakeVSXuGfxLib.txt)

################################################################################
# CMAKE PACKAGES ###############################################################
################################################################################
find_package(Threads REQUIRED)
find_package(OpenGL REQUIRED)


################################################################################
# INCLUDES #####################################################################
################################################################################

include_directories(
  ${OPENGL_INCLUDE_DIR}
  ${CMAKE_SOURCE_DIR}/
  ${CMAKE_SOURCE_DIR}/lib/application/include
  ${CMAKE_SOURCE_DIR}/lib/common/include
  ${CMAKE_SOURCE_DIR}/lib/engine/include
  ${CMAKE_SOURCE_DIR}/lib/engine_graphics/include
  ${CMAKE_SOURCE_DIR}/programs/player/src
)

file(GLOB_RECURSE HEADER_FILES *.h)

################################################################################
# DEFINES ######################################################################
################################################################################
add_definitions(
 -DVSX_FONT_NO_FT
 -DDEBUG
 -DVSXU_DEVELOPER
 -DVSXU_ARTISTE
 -DVSXU_MULTIMONITOR
 -DCMAKE_INSTALL_PREFIX="${CMAKE_INSTALL_PREFIX}"
)

if(VSXU_DEBUG EQUAL 1)
  add_definitions( -DVSXU_DEBUG )
endif()

################################################################################
# SOURCES ######################################################################
################################################################################

set(SOURCES
  src/main.cpp
)

# Solve the problem with DPI scaling
# since we want our own rc file
if(WIN32)
    set(CMAKE_EXE_LINKER_FLAGS "/MANIFEST:NO")
    set(SOURCES ${SOURCES} player.rc)
endif()


################################################################################
# LINK #########################################################################
################################################################################

add_executable(${module_id} ${SOURCES} ${HEADER_FILES})
include(${CMAKE_SOURCE_DIR}/cmake_suffix.txt)

if(UNIX)
  if (VSXU_STATIC)
    target_link_libraries(
      ${module_id}
      ${CMAKE_THREAD_LIBS_INIT}
      ${GLEW_LIBRARIES}
      ${OPENGL_LIBRARIES}
      vsx_application
      ${VSXU_GFX_LIB_LIBS}
      vsx_common
      vsx_compression
      vsx_engine
      vsx_engine_graphics
      plugins
      rt
      vsx_common
      vsx_compression
      vsx_engine
      vsx_engine_graphics
      plugins
    )
  else()
    target_link_libraries(
      ${module_id}
      ${CMAKE_THREAD_LIBS_INIT}
      ${GLEW_LIBRARIES}
      ${OPENGL_LIBRARIES}
      vsx_application
      ${VSXU_GFX_LIB_LIBS}
      vsx_common
      vsx_compression
      vsx_engine
      vsx_engine_graphics
      rt
    )
  endif()
endif()

if(WIN32)
  target_link_libraries(
   ${module_id}
   wsock32
   ws2_32
   vsx_application
   vsx_engine_graphics
   vsx_engine
   vsx_common
   vsx_compression
   ${PNG_LIBRARIES}
   ${ZLIB_LIBRARIES}
   ${JPEG_LIBRARIES}
   gdi32
   ${CMAKE_THREAD_LIBS_INIT}
   ${OPENGL_LIBRARIES}
   ${VSXU_GFX_LIB_LIBS}
)
endif()

if (VSXU_STATIC EQUAL 1)
  add_definitions(-DVSXU_STATIC)
endif()



if (VSXU_STATIC EQUAL 1)
  target_link_libraries(${module_id} plugins)
endif()


################################################################################
## INSTALL #####################################################################
################################################################################

install(TARGETS ${module_id} DESTINATION ${VSXU_INSTALL_BIN_DIR} COMPONENT player)
install(
  DIRECTORY
    ${CMAKE_SOURCE_DIR}/share/visuals_faders
    ${CMAKE_SOURCE_DIR}/share/visuals_player
    ${CMAKE_SOURCE_DIR}/share/visuals_packs
    ${CMAKE_SOURCE_DIR}/share/font
  DESTINATION
    ${VSXU_INSTALL_SHARE_DIR}
  COMPONENT player
)


IF (UNIX)
  CONFIGURE_FILE (${CMAKE_CURRENT_SOURCE_DIR}/vsxu-player-fullscreen.desktop.in
                  ${CMAKE_CURRENT_BINARY_DIR}/vsxu-player-fullscreen.desktop
                  @ONLY)
  CONFIGURE_FILE (${CMAKE_CURRENT_SOURCE_DIR}/vsxu-player.desktop.in
                  ${CMAKE_CURRENT_BINARY_DIR}/vsxu-player.desktop
                  @ONLY)

  INSTALL (FILES ${CMAKE_CURRENT_BINARY_DIR}/vsxu-player-fullscreen.desktop
                 ${CMAKE_CURRENT_BINARY_DIR}/vsxu-player.desktop
           DESTINATION ${CMAKE_INSTALL_PREFIX}/share/applications/)
ENDIF (UNIX)

=== lib/engine_graphics/thirdparty/ftgl/debian/changelog ===
ftgl (2.1.3~rc5-5polyextr~xenial) xenial; urgency=medium

  * Improved discovery for cmake

 -- Richard Ulrich <richi@paraeasy.ch>  Wed, 19 Oct 2016 20:38:43 +0200

ftgl (2.1.3~rc5-10polyextr~quantal) quantal; urgency=low

  * Added the cmake finder to the debian/install file

 -- Richard Ulrich <richi@paraeasy.ch>  Thu, 01 Nov 2012 23:40:43 +0100

ftgl (2.1.3~rc5-9polyextr~precise) precise; urgency=low

  * another try to get launchpad to build the package 

 -- Richard Ulrich <richi@paraeasy.ch>  Mon, 24 Sep 2012 21:06:44 +0200

ftgl (2.1.3~rc5-8polyextr~precise) precise; urgency=low

  * not building the tests if cxxtest not found 

 -- Richard Ulrich <richi@paraeasy.ch>  Thu, 13 Sep 2012 22:41:38 +0200

ftgl (2.1.3~rc5-7polyextr~precise) precise; urgency=low

  * added some tests 

 -- Richard Ulrich <richi@paraeasy.ch>  Fri, 14 Sep 2012 00:15:42 +0200

ftgl (2.1.3~rc5-6polyextr~precise) precise; urgency=low

  * Fixed a bug with spaces in the text as reported on http://blog.ulrichard.ch/?p=64

 -- Richard Ulrich <richi@paraeasy.ch>  Thu, 26 Jan 2012 21:19:02 +0000

ftgl (2.1.3~rc5-5polyextr~precise) precise; urgency=low

  * Added build dependency for cmake

 -- Richard Ulrich <richi@paraeasy.ch>  Wed, 09 Nov 2011 22:09:02 +0000

ftgl (2.1.3~rc5-4polyextr~precise) precise; urgency=low

  * Changes for polygon extraction

 -- Richard Ulrich <richi@paraeasy.ch>  Wed, 09 Nov 2011 22:09:02 +0000

ftgl (2.1.3~rc5-3ubuntu1) precise; urgency=low

  * Build-depend on doxygen-latex. Closes: #616215. LP: #749191.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 01 Sep 2011 22:09:02 +0000

ftgl (2.1.3~rc5-3) unstable; urgency=low

  * Change package format to 3.0 (quilt).
  * debian/control:
    + epstopdf was moved to texlive-font-utils, build-depending on it
      instead of texlive-extra-utils (Closes: #562315).
    + Set policy to 3.8.3.
    + Add ${misc:Depends} to all package dependencies.

 -- Sam Hocevar <sho@debian.org>  Sun, 03 Jan 2010 14:00:17 +0100

ftgl (2.1.3~rc5-2) unstable; urgency=low

  * debian/rules:
    + Make the package parralel-build safe. Thanks to Paul Wise for the hint.

 -- Sam Hocevar (Debian packages) <sam+deb@zoy.org>  Mon, 16 Jun 2008 14:32:00 +0000

ftgl (2.1.3~rc5-1) unstable; urgency=low

  * New development snapshot.
  * API is now stable, uploading to unstable.

 -- Sam Hocevar (Debian packages) <sam+deb@zoy.org>  Sun, 15 Jun 2008 17:12:15 +0200

ftgl (2.1.3~rc4-1) experimental; urgency=low

  * New development snapshot.
  * debian/control:
    + Set policy to 3.8.0.

 -- Sam Hocevar (Debian packages) <sam+deb@zoy.org>  Mon, 09 Jun 2008 11:56:12 +0000

ftgl (2.1.3~rc3-2) experimental; urgency=low

  * debian/control:
    + Build-depend on texlive-latex-recommended and texlive-fonts-recommended
      so that a4.sty, a4wide.sty and the appropriate fonts are present.
    + Build-depend on ghostscript because texlive-extra-utils only recommends
      it (despite shipping eps2pdf).

 -- Sam Hocevar (Debian packages) <sam+deb@zoy.org>  Mon, 12 May 2008 11:55:15 +0000

ftgl (2.1.3~rc3-1) experimental; urgency=low

  * New development snapshot.
  * debian/control: build-depend on doxygen, imagemagick, texlive-latex-base,
    texlive-base-bin, texlive-extra-utils to build documentation
    (Closes: #480048).

 -- Sam Hocevar (Debian packages) <sam+deb@zoy.org>  Sun, 11 May 2008 22:27:30 +0000

ftgl (2.1.3~rc2-1) experimental; urgency=low

  * New development snapshot. Fixes a few upstream bugs.

  * debian/control: build-depend on libcppunit-dev to fix an FTBFS
    (Closes: #479356).
  * debian/libftgl-dev.examples: add the simple demos as examples.

 -- Sam Hocevar (Debian packages) <sam+deb@zoy.org>  Wed, 07 May 2008 07:24:51 +0000

ftgl (2.1.3~rc1-1) experimental; urgency=low

  * Snapshot from upstream's development tree, targeted at experimental so
    that people can try dynamically linking with libftgl.
  * Ship full HTML documentation (Closes: #257155).

 -- Sam Hocevar (Debian packages) <sam+deb@zoy.org>  Wed, 30 Apr 2008 12:15:11 +0000

ftgl (2.1.2-4) unstable; urgency=low

  * New maintainer (Closes: #471983).

  * debian/control:
    + Do not build-depend on g++ (Closes: #268594).
    + Changed 'libglut3-dev | glutg3-dev' build-dependency to freeglut3-dev
      (Closes: #394492).
    + Uncapitalised short description.
    + Set policy to 3.7.3.
    + Add Vcs control fields.

  * debian/rules:
    + Use debian/compat instead of DH_COMPAT.
    + Use quilt for patch management.

  * debian/patches/000_package_version.diff:
    + New patch. Fix the version string in .pc files (Closes: #274400).

 -- Sam Hocevar (Debian packages) <sam+deb@zoy.org>  Sat, 12 Apr 2008 09:00:51 +0000

ftgl (2.1.2-3) unstable; urgency=low

  * src/FTVectoriser.cpp, unix/config.guess, unix/config.sub: patch and
    update for GNU/kFreeBSD.  Thanks Petr Salinger.  closes: bug#340720
  * include/FTTextureGlyph.h: funny bug.  Remove class qualification
    from static method declaration.  Thanks Martin Michlmayr.  closes:
    bug#355744
  * unix/ftgl.pc.in: hack to include -I/usr/include/FTGL in the include
    flags.  Thanks Jonathan Brandmeyer.  closes: bug#257660
  * debian/control: {build}-depend on libGLU.

 -- Marcelo E. Magallon <mmagallo@debian.org>  Fri, 28 Apr 2006 11:44:43 -0600

ftgl (2.1.2-2) unstable; urgency=low

  * debian/control: (build-)?depend on xlibmesa-gl-dev | libgl-dev.
    Thanks Matthias.  Closes: bug#311282.
  * debian/rules: build a _pic library, just like the X packages do.
    (closes: bug# 315330)
  * Please note that the previous change means that the packages that
    build shared libraries which include FTGL are _broken_ now.  These
    include gem and vtk, perhaps blender.
  * debian/control: change libstdc++-dev dependency to g++.  g++ is an
    actual package, libstdc++-dev is a virtual one.

 -- Marcelo E. Magallon <mmagallo@debian.org>  Sat, 02 Jul 2005 18:39:41 -0600

ftgl (2.1.2-1) unstable; urgency=low

  * New Upstream Release.



=== lib/engine_graphics/thirdparty/ftgl/debian/control ===
Source: ftgl
Section: libs
Priority: optional
Maintainer: Sam Hocevar <sho@debian.org>
Build-Depends: debhelper (>= 5.0), quilt, libgl1-mesa-dev | libgl-dev, libglu1-mesa-dev | libglu-dev, libfreetype6-dev (>> 2.0.9), freeglut3-dev, libcppunit-dev, doxygen, imagemagick, texlive-latex-base, texlive-base-bin, texlive-font-utils, texlive-latex-recommended, texlive-fonts-recommended, ghostscript, cmake
Standards-Version: 3.8.3

Package: libftgl-dev
Section: libdevel
Architecture: any
Depends: libftgl2 (= ${binary:Version}), libfreetype6-dev (>> 2.0.9), libgl1-mesa-dev | libgl-dev, libglu1-mesa-dev | libglu-dev, ${shlibs:Depends}, ${misc:Depends}
Conflicts: ftgl-dev (<< 2.1.3~rc1)
Replaces: ftgl-dev (<< 2.1.3~rc1)
Description: development files for libftgl
 FTGL binds OpenGL and FreeType together in order to offer and easy to use
 and flexible text rendering library.  It offers several rendering modes:
 as polygons, outlines, bitmaps and textures.
 .
 This package contains the header files and static libraries needed to
 compile applications or shared objects that use libftgl.

Package: libftgl2
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: library to render text in OpenGL using FreeType
 FTGL binds OpenGL and FreeType together in order to offer and easy to use
 and flexible text rendering library.  It offers several rendering modes:
 as polygons, outlines, bitmaps and textures.
 .
 This package contains the shared library for libftgl.

Package: ftgl-dev
Section: oldlibs
Architecture: all
Depends: libftgl-dev, ${misc:Depends}
Description: transitional dummy package
 This is a transitional dummy package.  If nothing depends on it, this
 package can be safely removed.

=== lib/engine_graphics/thirdparty/ftgl/debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 to 1999 by Joey Hess.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

CFLAGS = -Wall -g

DTMPDIR = $(CURDIR)/debian/tmp

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
CFLAGS += -O0
else
CFLAGS += -O2
endif
ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
INSTALL_PROGRAM += -s
endif

configure: configure-stamp
configure-stamp:
	dh_testdir
	QUILT_PATCHES=debian/patches quilt push -a || test $$? = 2
#	./configure --prefix=/usr --mandir=\$${prefix}/share/man --infodir=\$${prefix}/share/info
	touch $@

build: build-stamp
build-stamp: configure-stamp
	dh_testdir
#	$(MAKE) CFLAGS="$(CFLAGS)"
	mkdir -p $(CURDIR)/build-debian
	(cd $(CURDIR)/build-debian; cmake -DCMAKE_VERBOSE_MAKEFILE:BOOL=1 -DCMAKE_INSTALL_PREFIX:PATH=/usr -DCMAKE_BUILD_TYPE:STRING=Release ..)

	(cd $(CURDIR)/build-debian; $(MAKE) )
	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp
	rm -rf $(CURDIR)/build-debian
	[ ! -f Makefile ] || $(MAKE) distclean
	QUILT_PATCHES=debian/patches quilt pop -a -R || test $$? = 2
	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_clean -k
	(cd $(CURDIR)/build-debian; $(MAKE) install DESTDIR=$(DTMPDIR) )
#	mv debian/tmp/usr/share/doc/ftgl debian/tmp/usr/share/doc/libftgl-dev
	dh_install --list-missing --sourcedir=debian/tmp

binary-indep: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs -i ChangeLog
	dh_installdocs -i
	dh_installexamples -i
	dh_compress -i
	dh_fixperms -i
	dh_installdeb -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i

binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs -a ChangeLog
	dh_installdocs -a
	dh_installexamples -a
#	dh_installdebconf -a
#	dh_installmenu -a
#	dh_installinfo -a
	dh_installman -a
#	dh_undocumented -a
	dh_link -a
	dh_strip -a
	dh_compress -a
	dh_fixperms -a
	dh_makeshlibs -p libftgl2 -V 'libftgl2 (>= 2.1.3~rc5)'
	dh_installdeb -a
	dh_shlibdeps -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure
